// DlgGASettings.cpp : implementation file
//

#include "stdafx.h"
#include "cesim.h"
#include "DlgGASettings.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgGASettings dialog
CDlgGASettings::CDlgGASettings(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgGASettings::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgGASettings)
	m_prob_cross = 0;
	m_grid_size = 0;
	m_chr_len = 0;
	m_prob_mut_move = 0;
	m_prob_mut_sm_move = 0;
	m_prob_mut_swap = 0;
	m_population = 0;
	m_weight_intersections = 0;
	m_weight_edgelength = 0;
	m_weight_objdistance_min = 0;
	m_weight_objdistance_max = 0;
	//}}AFX_DATA_INIT
}

void CDlgGASettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgGASettings)
	DDX_Control(pDX, IDC_EDIT_GRID_SIZE, m_edit_grid);
	DDX_Control(pDX, IDC_EDIT_POPULATION, m_edit_population);
	DDX_Text(pDX, IDC_EDIT_CROSS, m_prob_cross);
	DDV_MinMaxInt(pDX, m_prob_cross, 0, 100);
	DDX_Text(pDX, IDC_EDIT_GRID_SIZE, m_grid_size);
	DDX_Text(pDX, IDC_EDIT_CHROMOZOME_LEN, m_chr_len);
	DDX_Text(pDX, IDC_EDIT_MUT_MOVE, m_prob_mut_move);
	DDV_MinMaxInt(pDX, m_prob_mut_move, 0, 100);
	DDX_Text(pDX, IDC_EDIT_MUT_SM_MOVE, m_prob_mut_sm_move);
	DDV_MinMaxInt(pDX, m_prob_mut_sm_move, 0, 100);
	DDX_Text(pDX, IDC_EDIT_MUT_SWAP, m_prob_mut_swap);
	DDV_MinMaxInt(pDX, m_prob_mut_swap, 0, 100);
	DDX_Text(pDX, IDC_EDIT_POPULATION, m_population);
	DDV_MinMaxInt(pDX, m_population, 3, 999);
	DDX_Text(pDX, IDC_EDIT_INTERSECTIONS, m_weight_intersections);
	DDX_Text(pDX, IDC_EDIT_LENGTH, m_weight_edgelength);
	DDX_Text(pDX, IDC_EDIT_DISTANCE_MIN, m_weight_objdistance_min);
	DDX_Text(pDX, IDC_EDIT_DISTANCE_MAX, m_weight_objdistance_max);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgGASettings, CDialog)
	//{{AFX_MSG_MAP(CDlgGASettings)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgGASettings message handlers
BOOL CDlgGASettings::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_edit_grid.EnableWindow(m_started? 0 : 1);
	m_edit_population.EnableWindow(m_started? 0 : 1);
	
	return TRUE;
}
